#pragma once
#include "grbc/generator.h"
#include <string>

/**
 * Generate the build rule for compiling c++ files
 */
std::string ninja_build_rule_compile_cxx();

/**
 * Generate the build rule for compiling c files
 */
std::string ninja_build_rule_compile_cc();

/**
 * Generate the build rule for linking c++ object files
 */
std::string ninja_build_rule_link_cxx();

/**
 * Generate the build rule for linking c object files
 */
std::string ninja_build_rule_link_cc();

/**
 * Generate the build rule for archiving object files into a shared library
 */
std::string ninja_build_rule_archive_library();

/**
 * Generate a line which builds the given file
 */
std::string
ninja_build_rule_compile_file(const GeneratorCompileCommand &compile_cmd);

/**
 * Default variables such as builddir
 */
std::string ninja_build_default_variables();

/**
 * Generate a line which links the given file to an executable
 */
std::string
ninja_build_rule_link_exe_target(const GeneratorLinkTargetCommand &link_cmd);

/**
 * Generate a line which links the given file to a library
 */
std::string
ninja_build_rule_link_lib_target(const GeneratorLinkTargetCommand &link_cmd);

/**
 * Generate a line which describes the given task
 */
std::string ninja_build_rule_task(const GeneratorTask &task);